moeoEntropyMetric(3)

NAME
moeoEntropyMetric - The entropy gives an idea of the diversity of a Pareto set relatively to another (Basseur, Seynhaeve, Talbi: 'Design of Multi-objective Evolutionary Algorithms: Application to the Flow-shop Scheduling Problem', in Proc.

SYNOPSIS

#include <moeoEntropyMetric.h>

Inherits moeoVectorVsVectorBinaryMetric< ObjectiveVector, double >.

  Public Member Functions
double operator() (const std::vector< ObjectiveVector > &_set1, const std::vector< ObjectiveVector > &_set2)
Returns the entropy of the Pareto set '_set1' relatively to the Pareto set '_set2'.

  Private Member Functions
void removeDominated (std::vector< ObjectiveVector > &_f)
Removes the dominated individuals contained in _f.
void prenormalize (const std::vector< ObjectiveVector > &_f)
Prenormalization.
void normalize (std::vector< ObjectiveVector > &_f)
Normalization.
void computeUnion (const std::vector< ObjectiveVector > &_f1, const std::vector< ObjectiveVector > &_f2, std::vector< ObjectiveVector > &_f)
Computation of the union of _f1 and _f2 in _f.
unsigned int howManyInNicheOf (const std::vector< ObjectiveVector > &_f, const ObjectiveVector &_s, unsigned int _size)
How many in niche.
double euclidianDistance (const ObjectiveVector &_set1, const ObjectiveVector &_to, unsigned int _deg=2)
Euclidian distance.

  Private Attributes
std::vector< double > vect_min_val
vector of min values
std::vector< double > vect_max_val
vector of max values
moeoParetoObjectiveVectorComparator< ObjectiveVector > paretoComparator
Functor to compare two objective vectors according to Pareto dominance relation.

Detailed Description

  template<class ObjectiveVector> class moeoEntropyMetric< ObjectiveVector >
The entropy gives an idea of the diversity of a Pareto set relatively to another (Basseur, Seynhaeve, Talbi: 'Design of Multi-objective Evolutionary Algorithms: Application to the Flow-shop Scheduling Problem', in Proc. of the 2002 Congress on Evolutionary Computation, IEEE Press, pp. 1155-1156)

Definition at line 25 of file moeoEntropyMetric.h.

Member Function Documentation

  template<class ObjectiveVector> double moeoEntropyMetric< ObjectiveVector >::operator() (const std::vector< ObjectiveVector > & _set1, const std::vector< ObjectiveVector > & _set2) [inline]

Returns the entropy of the Pareto set '_set1' relatively to the Pareto set '_set2'.

Parameters:
    _set1 the first Pareto set
    _set2 the second Pareto set

Definition at line 34 of file moeoEntropyMetric.h.

References moeoEntropyMetric< ObjectiveVector >::computeUnion(), moeoEntropyMetric< ObjectiveVector >::howManyInNicheOf(), moeoEntropyMetric< ObjectiveVector >::normalize(), moeoEntropyMetric< ObjectiveVector >::prenormalize(), and moeoEntropyMetric< ObjectiveVector >::removeDominated().

  template<class ObjectiveVector> void moeoEntropyMetric< ObjectiveVector >::removeDominated (std::vector< ObjectiveVector > & _f) [inline, private]

Removes the dominated individuals contained in _f.

Parameters:
    _f a Pareto set

Definition at line 85 of file moeoEntropyMetric.h.

References moeoEntropyMetric< ObjectiveVector >::paretoComparator.

Referenced by moeoEntropyMetric< ObjectiveVector >::operator()().

  template<class ObjectiveVector> void moeoEntropyMetric< ObjectiveVector >::prenormalize (const std::vector< ObjectiveVector > & _f) [inline, private]

Prenormalization.

Parameters:
    _f a Pareto set

Definition at line 107 of file moeoEntropyMetric.h.

References moeoEntropyMetric< ObjectiveVector >::vect_max_val, and moeoEntropyMetric< ObjectiveVector >::vect_min_val.

Referenced by moeoEntropyMetric< ObjectiveVector >::operator()().

  template<class ObjectiveVector> void moeoEntropyMetric< ObjectiveVector >::normalize (std::vector< ObjectiveVector > & _f) [inline, private]

Normalization.

Parameters:
    _f a Pareto set

Definition at line 129 of file moeoEntropyMetric.h.

References moeoEntropyMetric< ObjectiveVector >::vect_max_val, and moeoEntropyMetric< ObjectiveVector >::vect_min_val.

Referenced by moeoEntropyMetric< ObjectiveVector >::operator()().

  template<class ObjectiveVector> void moeoEntropyMetric< ObjectiveVector >::computeUnion (const std::vector< ObjectiveVector > & _f1, const std::vector< ObjectiveVector > & _f2, std::vector< ObjectiveVector > & _f) [inline, private]

Computation of the union of _f1 and _f2 in _f.

Parameters:
    _f1 the first Pareto set
    _f2 the second Pareto set
    _f the final Pareto set

Definition at line 142 of file moeoEntropyMetric.h.

Referenced by moeoEntropyMetric< ObjectiveVector >::operator()().

Author

Generated automatically by Doxygen for ParadisEO-MOEO from the source code.